# mymodule.py
def bracket(value, lower=0, upper=None):
   """Limit a value to a specific range (lower, upper)"""
   if upper:
       value = min(value, upper)
   return max(value, lower)

def apply_to_list(func, target_list):
    """Apply function func to each element of the target list)"""
    return [func(x) for x in target_list]

if __name__=='__main__':
    x = [-1, 2, 3]
    x_bracket = apply_to_list(bracket, x)
    print "Original List:", x
    print "Bracketed List: ", x_bracket

