import pylab, numpy
#!==============================
#! NeuroTools.signals
#!==============================
import NeuroTools.signals as signals
#! loading spiking data

s = signals.load_spikelist('spike_data')

#! raster plot
s.raster_plot(display=True)
pylab.title('raster plot')
pylab.xlim(500,1500.)
pylab.show()

#! mean rate
print 'mean rate: ',s.mean_rate()
print 'mean rates: ',s.mean_rates()

#! fano factor of isi
print 'fano factor of isi: ',s.fano_factors_isi()

#! cv of isi
print 'cv of isi:',s.cv_isi()

#! isi distribution
hs = s.isi_hist(bins=20, display=True)
pylab.show()

#! many more functions
print dir(signals.SpikeList)

#! loading voltage data
v = signals.load_vmlist('vm_data')

#! plot all the signals
v.plot(display=True)
pylab.title('all membranes')
pylab.xlim(500,1500.)
#pylab.show()

#! plot only one AnalogSignal
v[1].plot(display=True)
pylab.title('only one membrane')
pylab.xlim(500,1500.)
#pylab.show()

#! spike triggered averages
v.event_triggered_average(s,t_min=50.,display=True)
pylab.show()

#! many more functions
print dir(signals.AnalogSignal)

