import unittest
import basic_agents
from testingTools import get_mock_game
from goeast_agents import GoEastAgent

class GoEastTestCase(unittest.TestCase):
    def test_east(self):
        layout_txt = """%%%%%%%%
                        %     2%
                        %     .%
                        %1     %
                        %%%%%%%%
                        """
        # BasicAgent does nothing by default
        lt, game = get_mock_game(layout_txt, [GoEastAgent(0),
                                              basic_agents.BasicAgent(1)])
        game._init_run()
        
        # test that the start position is correct (unnecessary in general)
        assert game.state.getAgentPosition(0) == (1,1)
        game._one_game_step()
        # test that the agent really moved east!
        assert game.state.getAgentPosition(0) == (2,1)

if __name__=='__main__':
    unittest.main()
    