from game import Directions
import random
from numpy import argmin
from basic_agents import BasicAgent
from runnaway_agents import RunnawayAgent
from go_agents import GoAgent_eat
 
class Group0Agent(BasicAgent):
    def register_initial_state(self, game_state):
        
        self.timing_ind=0
        super(Group0Agent, self).register_initial_state(game_state)
        self.height = game_state.getWalls().height
        self.width = game_state.getWalls().width
        self.list_of_directions = [] # main directions that will be followed
        self.eating_agent = GoAgent_eat(self.index)
        self.eating_agent.initialize(game_state)
        self.runnaway_agent = RunnawayAgent(self.index)
        self.msg_index=0
        if game_state.isOnRedTeam(self.index):
            self.team = 'red'
        else:
            self.team = 'blue'
        self.previous_status = 'eating'
        self.previous_position = game_state.getAgentPosition(self.index)
        
        global just_changed
        just_changed={}
        just_changed[self.index]=False
        
    def choose_action(self, game_state):
      try:  
        agent_position = game_state.getAgentPosition(self.index)
        #we check if we are dead
        are_we_dead = False
        something_changed=False

        if are_we_dead or (just_changed.has_key(self.teammate_index(game_state)) and just_changed[self.teammate_index(game_state)] ): 
            something_changed=True    
        just_changed[self.index]=False

        
        if self.manhatten_distance(agent_position, self.previous_position) >2:
             are_we_dead = True

        #if are_we_dead:
        #    curr_paths[self.index]=[]

                
        self.previous_position = game_state.getAgentPosition(self.index)
        if self.are_we_at_home(game_state, agent_position):
            if self.previous_status == 'eating' and len(self.list_of_directions) > 0 and  not something_changed:
                direction = self.keep_eating() 
                #print '================='
            else:
                #print '###################'
                direction = self.start_eating(game_state, agent_position)
                just_changed[self.index]=True
        else: # we are not at home
            # we want to find the distance from the closest ennemy
            agent_position = game_state.getAgentPosition(self.index)
            enemies_pos = self.get_team_positions(game_state, enemy_pos=True)
            enemies_dist = [100,100]
            index_enemy = 0
            # we find the closest enemy
            for enemy_pos in enemies_pos:
                if enemy_pos == None: 
                    enemies_dist[index_enemy] = 100
                else:
                    #
                    #try:
                        dist=len(self.eating_agent.get_path(agent_position, enemy_pos ))
                    #except:
                    #    dist = self.manhatten_distance(enemy_pos, agent_position)
                    #    print "exception in get_path!!"
                        enemies_dist[index_enemy] = dist
                index_enemy += 1
            closest_enemy_dist = min(enemies_dist)
            if closest_enemy_dist > 2: # I do not see the enemy
                #print self.previous_status
                #print len(self.list_of_directions)
                #print are_we_dead
                if self.previous_status == 'eating' and len(self.list_of_directions) > 0 and not are_we_dead:
                    direction = self.keep_eating()
                else:
                    direction = self.start_eating(game_state, agent_position)
            else: # I see an ennemy
                enemy_pos = enemies_pos[argmin(enemies_dist)]
                direction = self.get_away_from_them(game_state, agent_position, enemy_pos,
                                                                    closest_enemy_dist)
        try:                                                          
            msg="""
            Well, you can tell by the way I use my walk,
    I'm a woman's man, no time to talk.
    Music loud and women warm.
    I've been kicked around since I was born.
    And now it's all right, it's O.K.
    And you may look the other way.
    We can try to understand
    The New York Times' effect on man.
    Whether you're a brother
    Or whether you're a mother,
    You're stayin' alive, stayin' alive.
    Feel the city breakin'
    And ev'rybody shakin'
    And we're stayin' alive, stayin' alive.
    Ah, ha, ha, ha,
    Stayin' alive.
    Stayin' alive.
    Ah, ha, ha, ha,
    Stayin' alive.
    Well now, I get low and I get high
    And if I can't get either I really try.
    Got the wings of heaven on my shoes
    I'm a dancin' man and I just can't lose.
    You know it's all right, it's O.K.
    I'll live to see another day.
    We can try to understand
    The New York Times' effect on man.
    Whether you're a brother
    Or whether you're a mother,
    You're stayin' alive, stayin' alive.
    Feel the city breakin'
    And ev'rybody shakin'
    And we're stayin' alive, stayin' alive.
    Ah, ha, ha, ha,
    Stayin' alive.
    Stayin' alive.
    Ah, ha, ha, ha,
    Stayin' alive.
    Life goin' nowhere.
    Somebody help me.
    Somebody help me, yeah.
    Life goin' nowhere.
    Somebody help me, yeah.
    Stayin' alive
    Well, you can tell by the way I use my walk,
    I'm a woman's man, no time to talk.
    Music loud and women warm.
    I've been kicked around since I was born.
    And now it's all right, it's O.K.
    And you may look the other way.
    We can try to understand
    The New York Times' effect on man.
    Whether you're a brother
    Or whether you're a mother,
    You're stayin' alive, stayin' alive.
    Feel the city breakin'
    And ev'rybody shakin'
    And we're stayin' alive, stayin' alive.
    Ah, ha, ha, ha,
    Stayin' alive.
    Stayin' alive.
    Ah, ha, ha, ha,
    Stayin' alive.
    Life goin' nowhere.
    Somebody help me.
    Somebody help me, yeah.
    Life goin' nowhere.
    Somebody help me, yeah.
    Stayin' alive
    Life goin' nowhere.
    Somebody help me.
    Somebody help me, yeah.
    Life goin' nowhere.
    Somebody help me, yeah.
    Stayin' alive 
            
            """   
            self.timing_ind+=1                                                      
            if self.timing_ind==4:
                
                if self.msg_index>len(msg.split('\n')):
                    self.msg_index=0
                self.say(msg.split('\n')[self.msg_index])       
                self.msg_index+=1
                self.timing_ind=0
        except:
            pass
            
        return self.legalize_action(direction, game_state)
      except:
        return Directions.STOP

    def teammate_index(self, game_state):
        if self.is_red:
            ind=game_state.getRedTeamIndices()
        else:
            ind=game_state.getBlueTeamIndices()
        ind.remove(self.index)
        return ind[0]
        


    def manhatten_distance(self, pos1, pos2):
        '''Computes the Manhatten distance'''
        return abs(pos1[0]-pos2[0])+ abs(pos1[1]-pos2[1])
    
    def are_we_at_home(self, game_state, agent_position):
        '''Checks if we are in our part of the game'''
        if self.team == 'red' and agent_position[0] < self.width/2 - 1:
            return True
        elif self.team == 'blue' and agent_position[0] > self.width/2 + 1:
            return True
        else:
            return False
    
    def keep_eating(self):
        '''Returns a direction when the pacman keeps eating '''
        direction =  self.list_of_directions[0]
        self.list_of_directions.pop(0) # we remove this direction
        self.previous_status = 'eating' # useless
        return direction

    def start_eating(self, game_state, current_pos):
        '''Returns a direction when the pacman starts eating '''
        try:
            
            self.list_of_positions = self.eating_agent.calculate_path(game_state)[self.eating_agent.index]
            self.list_of_positions.insert(0, current_pos)
            self.list_of_directions = self.convert_list_of_positions_to_directions(self.list_of_positions)
            direction =  self.list_of_directions[0]
            self.list_of_directions.pop(0) # we remove this direction
            self.previous_status = 'eating'
        except:
            actions = game_state.getLegalActions(self.index)
            direction = random.choice(actions)
            self.previous_status = 'stucked'
        return direction
    
    def get_away_from_them(self, game_state, agent_position, enemy_pos, enemy_dist):
        '''Returns a direction when the pacman is fleeing '''
        assert not enemy_pos == None, "give a position for the enemy"
        self.previous_status = 'fleeing'
        return self.runnaway_agent.tell_me_how_to_flee(game_state, agent_position, enemy_pos, enemy_dist, self.list_of_directions)

    def next_position(self, direction, pos):
        '''Given a certain position and a future movement it returns the future
         position'''
        if direction == Directions.STOP:
            return pos
        if direction == Directions.EAST:
            return (pos[0] + 1, pos[1])
        if direction == Directions.WEST:
            return (pos[0] - 1, pos[1])
        if direction == Directions.NORTH:
            return (pos[0], pos[1] + 1)
        if direction == Directions.SOUTH:
            return (pos[0], pos[1] - 1)  
        
    def legal_actions(self, game_state):
        ''' current legal actions '''
        return game_state.getLegalActions(self.index)

    def legalize_action(self,action, game_state):
        '''If a given action is asked, it checks if it is possible and
        return Stop if not'''
        possible_actions = self.legal_actions(game_state)
        if action in possible_actions:
            return action
        else:
            return Directions.STOP
        
    def convert_next_position_to_direction(self, current_pos, next_pos):
        '''Converts a move given with 2 (neighbor) position to a Direction'''
        assert self.are_consecutive_positions(current_pos, next_pos) ,\
         "Positions are not consecutive"
        if current_pos[0] - next_pos[0] == 1:
            return Directions.WEST
        elif current_pos[0] - next_pos[0] == -1:
            return Directions.EAST
        elif current_pos[1] - next_pos[1] == 1:
            return Directions.SOUTH
        elif current_pos[1] - next_pos[1] == -1:
            return Directions.NORTH
    
    def are_consecutive_positions(self, pos1, pos2):
        '''
        Returns True if the 2 given positions are consecutive False when 
        They are not.
        '''
        if abs(pos1[0] - pos2[0]) + \
        abs(pos1[1] - pos2[1]) == 1    :
            return True
        else:
            return False
        
        
    def convert_list_of_positions_to_directions(self,list_positions):
        '''
        Takes a list of consecutive positions and converts it into a list
        of directions for the Agent
        '''
        for i in range(len(list_positions) - 1):
            assert self.are_consecutive_positions(list_positions[i],
                   list_positions[i + 1]), "Positions are not consecutive in"\
                   " the list at index %d" %i 
        list_directions = []
        for i in range(len(list_positions) - 1):
            list_directions.append(
                self.convert_next_position_to_direction(list_positions[i],
                                                        list_positions[i + 1]))
        return list_directions 
			
	
		
        
