from game import Directions
import random
from numpy import argmin
from basic_agents import BasicAgent

class RunnawayAgent(BasicAgent):
    def register_initial_state(self, game_state):
        super(RunnawayAgent, self).register_initial_state(game_state)
        # we should identify the size of the maze
        height = game_state.getWalls().height
        width = game_state.getWalls().width

#    def choose_action(self, game_state):
#        agent_position = game_state.getAgentPosition(self.index)
#        enemies_pos = self.get_team_positions(game_state, enemy_pos=True)
#        enemies_dist = [100,100]
#        index_enemy = 0
#        # we find the closest enemy
#        for enemy_pos in enemies_pos:
#            if enemy_pos == None: 
#                enemies_dist[index_enemy] = 100
#            else:
#                dist = self.manhatten_distance(enemy_pos, agent_position)
#                enemies_dist[index_enemy] = dist
#            index_enemy += 1
#        # considering only the closest we choose our move
#        if min(enemies_dist) > 50:# I do not see the enemy
#            decision = Directions.STOP
#        else:
#            print '______'
#            self.say('Leg it!!!')
#            enemy_pos = enemies_pos[argmin(enemies_dist)]
#            dist = min(enemies_dist)
#            intelligent_decisions = []
#            for potential_action in self.legal_actions(game_state):
#                potential_distance = self.manhatten_distance(enemy_pos,
#                                      self.next_position(potential_action, 
#                                                         agent_position))
#                print potential_action, potential_distance
#                if potential_distance > dist:
#                    intelligent_decisions.append(potential_action)
#            if intelligent_decisions == []:
#                decision = Directions.STOP
#            else:
#                decision = random.choice(intelligent_decisions)
#        return self.legalize_action(decision, game_state)
    
    def manhatten_distance(self, pos1, pos2):
        '''Computes the Manhatten distance'''
        return abs(pos1[0]-pos2[0])+ abs(pos1[1]-pos2[1])
    
    def tell_me_how_to_flee(self, game_state, agent_position, enemy_pos, enemy_dist, food_direction):
        '''Returns a directions to flee the closest ennemy'''
        intelligent_decisions = []
        for potential_action in self.legal_actions(game_state):
            potential_distance = self.manhatten_distance(enemy_pos,
                                  self.next_position(potential_action, 
                                                     agent_position))
            if potential_distance > enemy_dist:
                intelligent_decisions.append(potential_action)
        if intelligent_decisions == []:
            decision = Directions.STOP
        else:
            # check we are not going in an immediate dead end
            index_to_remove = []
            for act in intelligent_decisions:
                if self.how_many_walls(game_state, self.next_position(act, agent_position)) == 3:
                    index_to_remove.append(intelligent_decisions.index(act))
            for i in index_to_remove:
                intelligent_decisions.pop(i)
            if intelligent_decisions == []:
                decision = Directions.STOP
            else:
                if len(food_direction) > 0 and food_direction[0] in intelligent_decisions:
                    decision = food_direction[0]
                else:
                    decision = random.choice(intelligent_decisions)
        return decision
    
    def how_many_walls(self, game_state, pos):
        cpt = 0
        if game_state.hasWall(pos[0] + 1, pos[1]):
            cpt += 1
        if game_state.hasWall(pos[0] -1, pos[1]):
            cpt += 1
        if game_state.hasWall(pos[0], pos[1]+1):
            cpt += 1
        if game_state.hasWall(pos[0] + 1, pos[1]-1):
            cpt += 1
        return cpt
    
    def next_position(self, direction, pos):
        '''Given a certain position and a future movement it returns the future
         position'''
        if direction == Directions.STOP:
            return (int(pos[0]),int(pos[1]))
        if direction == Directions.EAST:
            return (int(pos[0] + 1), int(pos[1]))
        if direction == Directions.WEST:
            return (int(pos[0] - 1), int(pos[1]))
        if direction == Directions.NORTH:
            return (int(pos[0]), int(pos[1] + 1))
        if direction == Directions.SOUTH:
            return (int(pos[0]), int(pos[1] - 1))        
            

    def legal_actions(self, game_state):
        ''' current legal actions '''
        return game_state.getLegalActions(self.index)

    def legalize_action(self,action, game_state):
        '''If a given action is asked, it checks if it is possible and
        return Stop if not'''
        possible_actions = self.legal_actions(game_state)
        if action in possible_actions:
            return action
        else:
            return Directions.STOP
			
	
		
		
