import unittest
import sys
import Agents
import testingTools
import pickle
import os

class ScoringAgentTest(unittest.TestCase):
    def test__init__(self):
	sf=Agents.ScoringFunctions([0.1,0.1,0.1]).linear_feature_scoring_f
        testagent=Agents.ScoringAgent(3,sf)
	self.failUnlessEqual(testagent.index,3)
	
	
    def test_choose_action(self):
        sf=Agents.ScoringFunctions([0.1,0.1,0.1]).linear_feature_scoring_f 
        testagent=Agents.ScoringAgent(0,sf)
	
        layout_txt = """%%%%%%%%
                        %      %
                        %     .%
                        %1     %
                        %%%%%%%%
                        """
        lt, game = testingTools.get_mock_game(layout_txt, [testagent])
        game._init_run()
#	myfile=open('game_state.pkl','wb')
#	pickle.dump(game.state,myfile)
#	myfile.close()
	
	legalactions = game.state.getLegalActions(testagent.index)
	action = testagent.choose_action(game.state)
	self.failUnless(action in legalactions)
	
	
	layout_txt = """%%%%%%%%
                        %     1%
                        %     .%
                        %      %
                        %%%%%%%%	
                        """
        lt, game = testingTools.get_mock_game(layout_txt, [testagent])
        game._init_run()
	legalactions = game.state.getLegalActions(testagent.index)
	action = testagent.choose_action(game.state)
	self.failUnless(action in legalactions) 
	
        layout_txt = """%%%%%%%%
                        %      %
                        %     .%
                        %     1%
                        %%%%%%%%
                        """
        lt, game = testingTools.get_mock_game(layout_txt, [testagent])
        game._init_run()
	legalactions = game.state.getLegalActions(testagent.index)
	action = testagent.choose_action(game.state)
	self.failUnless(action in legalactions)
	
        layout_txt = """%%%%%%%%
                        %1     %
                        %     .%
                        %      %
                        %%%%%%%%
                        """
        lt, game = testingTools.get_mock_game(layout_txt, [testagent])
        game._init_run()
	legalactions = game.state.getLegalActions(testagent.index)
	action = testagent.choose_action(game.state)
	self.failUnless(action in legalactions)
	
	

    def test_throws_exceptions_for_all_mazes(self):	
	    filelist=os.listdir('/home/student/summerschool/project/pacman/layouts')
	    print filelist
	    for filename in filelist:
		    name,ext=os.path.splitext(filename)
		    if ext.upper() in ['.LAY']:
			    os.chdir('/home/student/summerschool/project/pacman')
			    try:
				   os.system('python capture.py -r GerdLorenzoAgentFactory -l '+name)
			    except:
				    self.fail('Our Agent in Maze ',name,' failed to run without exception')
	


if __name__=="__main__":
    unittest.main()