""" Group 2 basic agent which converts maze to graph"""

from basic_agents import BasicAgent, BasicAgentFactory
# import networking handling
import networkx as nx

class Group2BasicAgent(BasicAgent):
    """Superclass Agent creation with calculation for 
    optimal distances """

    def register_initial_state(self, game_state):
        """This method handles the initial setup of the agent.
        You should override it if you have any business to do
        before the game begins (e.g., analyzing the maze).
        Make sure to invoke the super method when you override this.
        """
        super(Group2BasicAgent, self).register_initial_state(game_state)
        self.my_maze = game_state.getWalls()
        self.maze_graph = nx.Graph()
        self.maze_graph.add_nodes_from(self.my_maze.asList(False))
#        print self.my_maze.width, "/", self.my_maze.height,      
        
        for xx in range(self.my_maze.width-1):
            for yy in range(self.my_maze.height-1):    
                if self.my_maze[xx][yy] == False:
                    if self.my_maze[xx+1][yy] == False:
                        self.maze_graph.add_edge((xx, yy), (xx+1, yy))
                    if self.my_maze[xx][yy+1] == False:
                        self.maze_graph.add_edge((xx, yy), (xx, yy+1))
