"""
TO START:
python capture.py -r Group2AgentFactory_2


"""

from basic_agents import BasicAgentFactory
#from game import Directions
#import unittest
import random
import paths
import networkx as nx
from Group2BasicAgent import Group2BasicAgent
from group2_3_Agents import Group2Agent_5
#from anja_Agents import AnjaAgent

class PatrollingAgentFactory(BasicAgentFactory):
    """ 
    Main class to load the agents
    """
    
    def get_agents_list(self):
        """Define which agents participate """
        return [PatrollingAgent, Group2Agent_5]

    
class PatrollingAgent(Group2BasicAgent):
    """
    Agent that patrols in own camp and attacks if required
    """
                
    def register_initial_state(self, game_state):
        """ Instantiate agent varables and populates maze graph """
        super(PatrollingAgent, self).register_initial_state(game_state)
        self.state = 'go_to'
        
        #self.target_pos = self.findRandomSpot()
        #self.target_pos = (5,1)
        self.target_pos  = None
        
        self.opponent_pos = None
        
    
    def where_our_food_is(self, game_state):
        """ Returns an array of nodes that contain agent' side food """
        if self.is_red:
            food_nodes = game_state.getRedFood().asList()
        else:
            food_nodes = game_state.getBlueFood().asList()       
        return food_nodes
        
        
    def choose_action(self, game_state, radar_range=9):
        """ Main method to control agent actions over time """
        #self.say(random.choice(['Patrolling', 'ATTACK!!!!']))
        self.my_pos = game_state.getAgentPosition(self.index)
 
        self.state = 'patrol'
        enemies = self.get_team_positions(game_state) 

        for opponent in enemies:
            if  opponent != None:
                # print "spotted enemy at", opponent
                if len(nx.astar_path(self.maze_graph, self.my_pos, opponent)) \
                    > radar_range:
                    self.state = 'patrol'
                else:
                    self.state = 'attack'
                    self.say('ATTACK!!!!')
                    self.opponent_pos = opponent
                    if self.in_our_camp():
                        return paths.action_to_reach(self.maze_graph, \
                            self.my_pos, self.opponent_pos)
                    else:
                        self.state = 'patrol'

        if self.state == 'patrol':
            self.say(random.choice(['patrolling', 'I am ready...', \
                'dubdidubdiduuuuuuu']))
            our_food = self.where_our_food_is(game_state)
            if self.target_pos not in our_food:
                self.target_pos = random.choice(our_food)
            if self.my_pos == self.target_pos:
                self.target_pos = random.choice(our_food)

        return paths.action_to_reach(self.maze_graph, self.my_pos, \
            self.target_pos)


    def in_our_camp(self):
        """Returns True if agent is in his own camp, or False if agent is
        oponents camp """
        _middle = (self.my_maze.width/2-1)
        if (self.is_red) and (self.my_pos[0] < _middle):
            return True
        if not (self.is_red) and (self.my_pos[0] > _middle+1):
            return True
        return False
        
            
        
       
