import random

from basic_agents import BasicAgent, BasicAgentFactory
from drunk_Agents import Group2DrunkAgent
from game import Directions
import networkx as nx

import paths
from Group2BasicAgent import Group2BasicAgent


class AnjaAgent(Group2BasicAgent):
    def choose_action(self, game_state):
        self.say(random.choice(['North', 'not South', 'uups']))
        actions = game_state.getLegalActions(self.index)
        if self.is_red:
            enemy_food = game_state.getBlueFood().asList()
        else:
            enemy_food = game_state.getRedFood().asList()
        
        self.my_pos = game_state.getAgentPosition(self.index)
        dist=list()
        for food in enemy_food:
            dist.append(len(nx.shortest_path(self.maze_graph, self.my_pos, food)))
        self.target_pos = enemy_food[dist.index(min(dist))]
        
        # our task!!!
        return paths.action_to_reach(self.maze_graph, self.my_pos, self.target_pos)
        # return Directions.STOP
        # return random.choice(actions)  # random guy
        # return Directions.NORTH   # north guy

class AnjaAgent2(Group2BasicAgent):
    def register_initial_state(self, game_state):
        """This method handles the initial setup of the agent.
        You should override it if you have any business to do
        before the game begins (e.g., analyzing the maze).
        Make sure to invoke the super method when you override this.
        """
        super(AnjaAgent2, self).register_initial_state(game_state)
        self.target_pos = None
                
        
    def choose_action(self, game_state):
        actions = game_state.getLegalActions(self.index)
        if self.is_red:
            our_food = game_state.getRedFood().asList()
        else:
            our_food = game_state.getBlueFood().asList()
        
        self.my_pos = game_state.getAgentPosition(self.index)
        # our_food.sort()
        if self.target_pos not in our_food:
            self.target_pos = random.choice(our_food)
        if self.my_pos == self.target_pos:
            self.target_pos = random.choice(our_food)
        
        # return paths.action_to_reach(self.maze_graph, self.my_pos, self.target_pos)
        return paths.action_to_reach(self.maze_graph, self.my_pos, self.target_pos)


class AnjaAgentFactory(BasicAgentFactory):
    def get_agents_list(self):
        return [AnjaAgent,AnjaAgent2]
