"""
Test suite for the converting grid to graph.
"""

import unittest

import graphs

class TestConversion(unittest.TestCase):
    """
    TestCase for weighted edges.
    """
    def setUp(self):
        """set up a test graph"""
        self.graph = graphs.Graph()
        self.graph.add_node(0)
        self.graph.add_node(1)
        self.graph.add_node(2)
        self.graph.add_node(3)
        self.graph.add_edge(0, [0, 1], {'cost':100, 'distance':50, 'label':'plane'})
        self.graph.add_edge(1, [0, 2], {'cost':10, 'distance':15, 'label':'car'})
        
    def tearDown(self):
        """Delete unneeded graph"""
        del self.graph
        
    def test_weights(self):
        """Verify reading weights of the nodes"""
        self.assertEqual(self.graph.edges[0].weights['cost'], 100)
        self.assertEqual(self.graph.edges[1].weights['cost'], 10)
        self.assertEqual(self.graph.edges[0].weights['distance'], 50)
        self.assertEqual(self.graph.edges[1].weights['label'], 'car')
        


if __name__ == '__main__':
    unittest.main()
