import unittest
import path_graph

class GameStateTestPath():
    def getWalls(self):
        test_grid= [[1, 1, 1, 1, 1],
                    [1, 0, 0, 0, 1],    
                    [1, 0, 1, 0, 1],
                    [1, 0, 0, 0, 1],
                    [1, 1, 1, 1, 1]]
        return test_grid
    
class GameStateTestBottleneck():
    def getWalls(self):
        test_grid= [[1, 1, 1, 1, 1],
                    [1, 0, 1, 0, 1],    
                    [1, 0, 0, 0, 1],
                    [1, 1, 1, 0, 1],
                    [1, 1, 1, 1, 1]]
        return test_grid
      
class FirstTestCase(unittest.TestCase):
    
    def test_path_extraction(self):
        game_state=GameStateTestPath()
        ag=path_graph.GraphKnowingAgent(0)
        ag.construct_graph(game_state)
        sp = ag.get_shortest_path((1, 1),(3, 2))
        print sp
        self.assertTrue(sp==[(1, 1),(2, 1),(3, 1),(3, 2)])
        
    def test_node_extraction(self):
        game_state=GameStateTestPath()
        ag=path_graph.GraphKnowingAgent(0)
        ag.construct_graph(game_state)
        sp = ag.get_neighbors((2, 1), 2)
        print sp
        self.assertTrue(sp=={(1, 1):1, (3, 1):1, (3, 2):2, (1, 2):2, (2, 1):0})
        
    def test_path_bottleneck(self):
        game_state=GameStateTestBottleneck()
        ag=path_graph.GraphKnowingAgent(0)
        ag.construct_graph(game_state)
        sp = ag.get_fullgraph_bottleneck()
        print sp
        self.assertTrue(sp[0]==(2,3))
        
if __name__ == '__main__':
    unittest.main()

        


