import basic_agents
from game import Directions
from basic_agents import BasicAgentFactory, BasicAgent
import random
import pdb

class MessageBoard(object):
    def __init__(self):
        self.text = {}

class CommunicationAgentFactory(BasicAgentFactory):
    def __init__(self, **args):
        super(BasicAgentFactory, self).__init__(**args)
        self._agents_list = self.get_agents_list()
        self._agent_idx = 0
        
    def get_agents_list(self):
        """Returns a list of Agent subclasses.
        If more agents are requested than provided, return a BasicAgent.
        
        This is the method to override to create new factories."""
        return [CommunicationAgent, CommunicationAgent]
   
    def getAgent(self, index): 
        """Returns the agent for the provided index."""
        if self._agent_idx == 0:
            self.message_board = MessageBoard()
        idx = self._agent_idx
        if idx >= len(self._agents_list):
            return BasicAgent(index)        
        agent_class = self._agents_list[self._agent_idx]
        self._agent_idx += 1
        agent = agent_class(index)
        agent.message_board = self.message_board
        print dir(agent)
        return agent


class CommunicationAgent(basic_agents.BasicAgent):
    
    def choose_action(self, game_state):
        actions = game_state.getLegalActions(self.index)
        choice = random.choice(actions)
        pdb.set_trace()	
        self.message_board.text[str(self.index)+': my next move']=choice 
        
        return choice

