from subsystem import Subsystem
from team4util import get_position

class KeepGoingSubsystem(Subsystem):
    def __init__(self, agent):
        super(KeepGoingSubsystem,self).__init__(agent)
        self.history = []

    def assess(self, game_state):        
        agent_position = get_position(game_state, self.agent.index)
        
        if len(self.history) > 5:
            self.history.pop(0) # removes from history positions from 5 steps ago.
        
        scores={}
        newposition={}
        for action in game_state.getLegalActions(self.agent.index):
            if action == 'Stop':
               newposition['Stop'] =  (agent_position[0], agent_position[1])
            elif action == 'North':
                newposition['North'] =  (agent_position[0], agent_position[1]+1)
            elif action == 'South':
                newposition['South'] =  (agent_position[0], agent_position[1]-1)
            elif action == 'East':
                newposition['East'] =  (agent_position[0]+1, agent_position[1])
            elif action == 'West':
                newposition['West'] =  (agent_position[0]-1, agent_position[1])
                
        
        for action in game_state.getLegalActions(self.agent.index):
            if action == 'Stop':
               scores[action] =  0
            else:
                scores[action] = 1
                for previous_position in self.history:
                    if newposition[action] == previous_position:
                        scores[action] = 0
                        
                                
        self.history.append(agent_position)                        
        print scores
        return scores


