import random
from basic_agents import BasicAgent, BasicAgentFactory
import pdb
from team4util import DistCalc

from numpy import inf


class RAAgent(BasicAgent):
    def register_initial_state(self, g):
        #pdb.set_trace()
        pass

    def scanEnemy(self, g):
        """Looks for enemies close.

        Returns list of tuples (enemy index, distance).
        E.g. [(1, 5), (3, inf)]
        """
        ret = []
        for enemy in self.getEnemies(g):
            if g.getAgentPosition(enemy) is not None:
                dist = self.calWalkDist(g, enemy)
                ret.append((enemy, dist))
        return ret
            
    def calWalkDist(self,g,index):
        """Calculate distance to walk to enemy=index
        taking into account walls.

        Returns distance in steps.
        """
        #        pdb.set_trace()
        calc = DistCalc(g.getWalls().data,
                        g.getAgentPosition(self.index),
                        g.getAgentPosition(index))
        #calc.print_distances()
        return calc.distance

    def getEnemies(self, g):
        # import pdb; pdb.set_trace()
        if g.isOnRedTeam(self.index):
            return g.getBlueTeamIndices()
        else: 
            return g.getRedTeamIndices()
        

    def choose_action(self, g):
        #        pdb.set_trace()
        self.say(random.choice(['Burp', 'Blah', 'Mrmmmf']))
        actions = g.getLegalActions(self.index)
        return random.choice(actions)
    
class RAFactory(BasicAgentFactory):
    def get_agents_list(self):
        return [RAAgent,RAAgent]

