import team4util
import pdb

class Subsystem(object):
    def __init__(self,agent):
        self.agent = agent
        self.dist_cache = {}

    def register_initial_state(self,game_state):

        self.walls = game_state.getWalls().data
        self.xsize = len(self.walls)
        self.ysize = len(self.walls[0])


    def assess(self, game_state):
        """returns the score for all possible actions in a given game state """
        

    def get_new_position(self,old_position,action):

        new_x,new_y = old_position
        if action == 'North':
            new_y += 1
        elif action == 'South':
            new_y -= 1
        elif action == 'West':
            new_x -= 1
        elif action == 'East':
            new_x += 1

        return new_x,new_y


    def dist_calc(self, walls, src, dst):            
        index = src, dst
        try:
            return self.dist_cache[index]
        except KeyError:
            self.dist_cache[index] = dist = team4util.DistCalc(walls, src, dst)
            return dist


class FoodSubsystem(Subsystem):
    take_upper = True
    
    def __init__(self, agent):
        super(FoodSubsystem,self).__init__(agent)
        self.take_upper = FoodSubsystem.take_upper
        FoodSubsystem.take_upper = not FoodSubsystem.take_upper
        print self.take_upper



    def assess(self, game_state):
        
        agent_position = team4util.get_position(game_state, self.agent.index)
        agent_red = not game_state.isOnRedTeam(self.agent.index)
        scores = dict([(t, 0) for t in game_state.getLegalActions(self.agent.index)])

        print self.agent.index, agent_red
        
        if agent_red:
            get_food=game_state.getRedFood
        else:
            get_food=game_state.getBlueFood

        is_non_zero = False
        
        for k in game_state.getLegalActions(self.agent.index):
            new_x,new_y = self.get_new_position(agent_position,k)
            scores[k] = int(get_food()[int(new_x)][int(new_y)])
            if scores[k]==1:
                is_non_zero = True

        if is_non_zero == False:
            rfoods = [(y,x)
                      for x in xrange(self.xsize)
                      for y in xrange(self.ysize)
                      if get_food()[x][y]]
            rfoods.sort()
            howmuch = len(rfoods)
            if self.take_upper:
                rfoods = rfoods[max(howmuch - howmuch/3 - 1, 0):]
            else:
                rfoods = rfoods[:howmuch/3 + 1]
            current_food_positions = [(x,y) for (y,x) in rfoods]

            for k in game_state.getLegalActions(self.agent.index):
                if k != "Stop":
                    new_x,new_y = self.get_new_position(agent_position, k)
                    current_dist = self.dist_calc(self.walls, (new_x,new_y), (0,0))
                    min_dist_to_food=min([current_dist.distances[pos] for pos in current_food_positions])
                    scores[k]=1./min_dist_to_food

        return scores

    

class EnemySubsystem(Subsystem):

    def assess(self, game_state):

        agent_position = team4util.get_position(game_state, self.agent.index)
        agent_red = game_state.isOnRedTeam(self.agent.index)
        scores = dict([(t, 0) for t in game_state.getLegalActions(self.agent.index)])

        if agent_red:
            get_indices=game_state.getBlueTeamIndices
        else:
            get_indices=game_state.getRedTeamIndices

        enemy_indices= get_indices()
        for enemy_id in enemy_indices:
            current_enemy_pos = team4util.get_position(game_state, enemy_id)
            if current_enemy_pos!=None:
                for k in game_state.getLegalActions(self.agent.index):
                    new_x,new_y = self.get_new_position(agent_position, k)
                    if (new_x,new_y) == current_enemy_pos:
                        if game_state.getAgentState(self.agent.index).isPacman:
                            scores[k] = 1
                        else:
                            scores[k] = -1
        return scores

