from bartosz_agents import GPAgent, my_flist
from testingTools import get_mock_game
import gp

layout_txt = """%%%%%%%%%%%%%%%%%%%%
                %..................%
                %..................%
                %..................%
                %..................%
                %..................%
                %..................%
                %..................%
                %    1             %
                %%%%%%%%%%%%%%%%%%%%"""

def scorefunction(tree):
    my_agent = GPAgent(0, tree)
    lt, game = get_mock_game(layout_txt, [my_agent])
    game._init_run()
    for i in xrange(20):
        game._one_game_step()
    score = my_agent.get_score(game.state)
    return score

def rankfunction(population):
    scores = [(scorefunction(t), t) for t in population]
    scores.sort()
    return scores

best = gp.evolve(2, 500, rankfunction, maxgen=100, mutationrate=0.1,
                 breedingrate=0.1,  pexp=0.7, pnew=0.1, func_list=my_flist)
print best.display()

