
# Stuff to be cleansed.

from rike_agents import *

class RikeUnreflexiveAgentSquad(RikeAgentSquad):
    """Temporary?"""
    def get_agents_list(self):
        return [SomeYetUnnamedAgent, SomeYetUnnamedAgent]
    

class SomeReflexiveYetUnnamedAgent(ReflexiveSpecialAgent):
    """Draft work. Might work, but needs to be vastly improved."""
    def __init__(self, index):
        super(SomeReflexiveYetUnnamedAgent, self).__init__(index)

    def register_initial_state(self, game_state):
        super(SomeReflexiveYetUnnamedAgent, self).register_initial_state(game_state)

        if not self.hq.maze_analyser:
            self.hq.maze_analyser = MazeAnalyser(game_state.getWalls().data)
        if not self.hq.shortest_path: 
            self.hq.shortest_path = ShortestPath(self.hq.maze_analyser)
        
        self.say(self.hq.agent_name(self))
        #if not hasattr(self, "hq"):
        #self.hq = None
    
    def get_features(self, game_state, action):
        features = util.Counter()
        successor = self.get_successor(game_state, action)

        myState = successor.getAgentState(self.index)
        myPos = myState.getPosition()
        
        if self.food_path:
            features['food_path'] = self.hq.maze_analyser.path_length(myPos, self.food_path[0])
        if self.fight_path:
            features['enemy_path'] = self.hq.maze_analyser.path_length(myPos, self.fight_path[0])
        if self.fear_p:
            features['fear_path'] = self.hq.maze_analyser.path_length(myPos, self.fear_p[0])
        
        return features
    
    def get_weights(self, game_state, action):
        return {'food_path': -1, 'enemy_path': -5, 'fear_path': 1}

    def is_killed(self, game_state):
        """Return True if the agent has been eaten on the previous turn.
        This version takes into account, that one might walk accidently
        or intendedly to the initial position.
        """
        return super(SomeReflexiveYetUnnamedAgent, self).is_killed(game_state) and \
            self.pos_now and self.pos_prev and \
            self.hq.maze_analyser.path_length(self.pos_now, self.pos_prev) > 1

    # old choose_action
    def path_calculation(self, game_state):
        #super(SomeReflexiveYetUnnamedAgent, self).choose_action(game_state)
        
        #if self.is_slave and self.lifetime_counter < 5:
        #        return Directions.STOP
        
        my_pos = self.get_position(game_state)
        
        food_c = self.get_food_coordinates(game_state, True)
        
        if self.hq.take_upper(self):
            upper_food = [food for food in food_c if food[0] < 3*self.maze_len_x//4]
            p = self.hq.shortest_path.solve_TSP(my_pos, upper_food)
            length = self.hq.shortest_path.length_of_path(p)
        else:
            upper_food = [food for food in food_c if food[0] >= 3*self.maze_len_x//4]
            p = self.hq.shortest_path.solve_TSP(my_pos, upper_food)
            length = self.hq.shortest_path.length_of_path(p)
            
        
        if self.hq.take_upper(self):
            upper_food = [food for food in food_c if food[1] < self.maze_len_y//2]
            p = self.hq.shortest_path.solve_TSP(my_pos, upper_food)
            length = self.hq.shortest_path.length_of_path(p)
        else:
            upper_food = [food for food in food_c if food[1] >= self.maze_len_y//2]
            p = self.hq.shortest_path.solve_TSP(my_pos, upper_food)
            length = self.hq.shortest_path.length_of_path(p)

             
        if not upper_food:
            upper_food = food_c
            
        best_path = self.hq.shortest_path.solve_TSP(my_pos, upper_food)
        best_path = [best_path[0]] + self.hq.shortest_path.solve_TSP(best_path[0], food_c)
        
        self.food_path = best_path
               
        # If enemies are close, try to fight them early 
        enemies = self.hq.enemies['history'][-1]
        enemies_tracked = False
        for e in enemies:
            if e is not None and self.is_on_our_side(e):
                best_path.insert(0, e)
                enemies_tracked = True

        if enemies_tracked:
            best_path = self.hq.shortest_path.solve_TSP(my_pos, best_path[0:5])
            self.fight_path = best_path
            self.say("Enemy alarm!")
        else:
            self.say(random.choice(["Foood!", "Hungry!"]))
            self.fight_path = []
        
        enemies_tracked = False

        for e in enemies:
            if e is not None and (not self.is_on_our_side(e) or my_pos in self.safe_points(game_state)):
                enemies_tracked = True        
        
        self.fear_p = []
        
        self.fear_distance = 4
        for dist, pos in self.distance_to_enemies(game_state) :
            if dist < self.fear_distance and (not self.is_on_our_side(pos) or my_pos in self.safe_points(game_state)):
                best_path = self.fear_path(game_state)
                self.fear_p = best_path
                self.say("Enemy alarm!")
                break

        if len(best_path):
            best_pos = best_path[0]
            
            if self.hq and self.is_slave:
                if len(self.hq.master.goes_for) > 1:
                    if best_pos == self.hq.master.goes_for[0]:
                        best_path.remove(best_pos)
                        best_path = self.hq.shortest_path.solve_TSP(my_pos, best_path[0:5])
        
            
        if self.lifetime_counter % 20 == 0:
            if self.is_master:
                self.hq.select_talk(random.choice(self.hq.talk_topics), self.index, self.hq.index_rand_slave)
        self.be_bright_or_be_quiet()

        self.path = best_path
        if self.hq:
            self.hq.master.goes_for = self.path
        
        
        try:
            way = self.hq.maze_analyser.get_shortest_path(my_pos, best_path[0] )[0][0]
        except IndexError:
            way = Directions.STOP
            
        if way in game_state.getLegalActions(self.index):
            return way
        return Directions.STOP
    
    def distance_to_enemies(self, game_state):
        """
        Returns a tuple of (distance, positions)
        """
        positions = self.hq.enemies['history'][-1]
        return [(self.hq.maze_analyser.path_length(self.get_position(game_state), p), p) for p in positions if p]
    
    def fear_path(self, game_state):
        possible_points = self.safe_points(game_state) 
        my_pos = self.get_position(game_state)
        
        possible_points_distances = map(lambda x: (x, self.hq.maze_analyser.path_length(x, my_pos)), possible_points)
        possible_points_distances.sort(key=lambda x: x[1])
        
        enemies = self.hq.enemies['history'][-1]
        enemy_path = filter(lambda x: x, enemies)
        
        path_to_take = None
        for pos in possible_points_distances:
            path = self.hq.shortest_path.get_shortest_path_for_agent(self, pos[0], game_state, fear_factor=0)
            enemy_in_path = False
            for e in enemy_path:
                if e in path: enemy_in_path = True
            if not enemy_in_path:
                path_to_take = path
                break
 
        path_to_take = map(lambda x: x[1], path_to_take)  
        return path_to_take


class MyReflexCaptureAgent(ProgressiveAgent):
    """
    A base class for reflex agents that chooses score-maximizing actions
    """
    def choose_action(self, game_state):
        """
        Picks among the actions with the highest Q(s,a).
        """
        actions = game_state.getLegalActions(self.index)
    
        # You can profile your evaluation time by uncommenting these lines
        # start = time.time()
        values = [self.evaluate(game_state, a) for a in actions]
        # print 'eval time for agent %d: %.4f' % (self.index, time.time() - start)
        max_value = max(values)
        best_actions = [a for a, v in zip(actions, values) if v == max_value]
    
        return random.choice(best_actions)

    def get_successor(self, game_state, action):
        """
        Finds the next successor which is a grid position (location tuple).
        """
        successor = game_state.generateSuccessor(self.index, action)
        pos = successor.getAgentState(self.index).getPosition()
        if pos != util.nearestPoint(pos): 
          # Only half a grid position was covered
            return successor.generateSuccessor(self.index, action)
        else:
            return successor

    def evaluate(self, game_state, action):
        """
        Computes a linear combination of features and feature weights
        """
        features = self.get_features(game_state, action)
        weights = self.get_weights(game_state, action)
        return features * weights

    def get_features(self, game_state, action):
        """
        Returns a counter of features for the state
        """
        features = util.Counter()
        successor = self.get_successor(game_state, action)
        features['successorScore'] = self.get_score(successor)
        return features

    def get_weights(self, game_state, action):
        """
        Normally, weights do not depend on the game_state.  They can be either
        a counter or a dictionary.
        """
        return {'successorScore': 1.0}

class PongAgent(MyReflexCaptureAgent):
    """
    Try to get as far as possible on the other side. If being followed: go back on your side.
    """
    def register_initial_state(self, game_state):
        super(PongAgent, self).registerInitialState(game_state)
    
    def is_on_own_side(self, game_state):
        half = self.maze_len_x // 2
        return game_state.getPosition()[0] < half
        
    def get_features(self, game_state, action):
        features = util.Counter()
        successor = self.get_successor(game_state, action)

        my_state = successor.getAgentState(self.index)

        self.is_on_own_side(my_state)
        features['successorScore'] = 2
        return features

    def get_weights(self, game_state, action):
        if action == "North":
            return {'successorScore': 2.0}
        else:
            return {}
      

class BlindAgendWithAMemory(BasicAgent):
    pass

