import capture
import layout
import textDisplay     

def layout_from_txt(layout_txt):
    """Get a raw unformatted string and convert it to a layout.Layout instance"""
    stripped = [ln.strip() for ln in layout_txt.splitlines() if len(ln.strip())>1]
    return layout.Layout(stripped)

def get_mock_game(layout_txt, agents, first_agent=0):
    """Set up a mock game with given layout and agents.
    Input arguments:
    layout_txt -- a string with the layout of the maze (see layout.py)
    agents -- a list of instances of Agent , the agents that are going to play
              the mock game
    first_agent -- 0 is the red team starts, 1 otherwise
    
    Return (layout, game)
    layout -- an instance of layout.Layout, object representing the maze
    game -- instance of game.Game, with which you can manipulate the game
    """
    lt = layout_from_txt(layout_txt)
    rules = capture.CaptureRules(maxMoveTime=100., timePenalty=0.)
    display = textDisplay.NullGraphics()
    return lt, rules.newGame(lt, agents, display, length=3000, starter=first_agent)
